//////////////////////////////////////////////////////////////////////////
//                                                                      //
// ldexpf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:08p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// ldexpf --
//
//     2   
//
float ldexpf(float f, int ip){
	int m, e, s, sc;

    //   float
	DestructFloat(f, m, e, s, sc);

    if (e == 128)		// NAN, inf
		return ConstructFloat(0x7fffff, 128, s, 0);

    if (m){
		if (e == -127){
            //  
			while ( !(m & 0x800000)){
				m<<=1;
				e--;
			}
			e++;
		}
	}
	else if (e == -127)     //  0
		return f;

	if (e+ip>127){          //  
		if (!_FPIEEE_Flags)
			_FPIEEE_Signal( _FPIEEE_Overflow );
		return ConstructFloat(0, 128, s, 0);
	}

    if (e+ip>-127)          //   
		return ConstructFloat(m, e+ip, s, 0);
	
    if (e+ip>-157){         //  
		while ( e+ip!=-127){
			m>>=1;
			ip++;
		}
		int Adder = m & 1;
		m>>=1;
        //   float
		return ConstructFloat(m+Adder, e+ip, s, 0);
	}
	
    //   float
    return ConstructFloat(0, -127, s, 0);
}

#ifdef __cplusplus
}
#endif
