//////////////////////////////////////////////////////////////////////////
//                                                                      //
// myauxf.cpp -                                                         //
//                                                                      //
//          ,         //
//        .                         //
//                                                                      //
// Copyright (c) 2001-2008 RC Module                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif  // __cplusplus

//          
extern unsigned int _FPIEEE_Flags;

// DestructFloat --
//
//   float
//

#if !defined(__NM6403__) && !defined(__NM6405__)

void DestructFloat(float f, int &Mantiss, int &Exponent, int &Sign, int& ){

	float *fp = &f;
	unsigned int *ip;
	ip= (unsigned int*)(fp);
	Mantiss = ( *ip &	0x007fffff );
	Exponent = (( *ip & 0x7f800000 ) >> 23 ) - 0x7f;
	Sign =  ( *ip &		0x80000000 ) >> 31;

	if (Exponent != 0x80 && Exponent !=-127)	// +0, -0 
		Mantiss += 0x00800000;	/* +1,   */
	return;
#else		//	    ..

void DestructFloat(float , int &, int &, int &, int& ){

	__asm{
	ar7 += 6;
	push ar0,gr0;
	push ar1,gr1;
                                  //<29,1>

//33:   	Mantiss = ( *ip &	0x007fffff );

	ar0 = ar6 set;                                  //<34,45>
	gr0 = [ar0-=5];
	gr1 = gr0 << 9;
	ar1 = [--ar0] with gr1 = gr1 >> 9;


//35:   	Sign =  ( *ip &		0x80000000 ) >> 31;

	ar5 = [--ar0] with gr7 = gr0 >> 31;
//34:   	Exponent = (( *ip & 0x7f800000 ) >> 23 ) - 0x7f;

	ar0 = [--ar0] with gr6 = gr0 << 1;
	if =0 delayed goto L_norm;
		gr0 = 255 with gr6 = gr6 >> 24;
	gr6 - gr0;
	if =0 delayed goto L_norm;
	gr0 = 8388608;

	gr1 = gr1 + gr0;
<L_norm>

	gr0 = 127;
	[ar1] = gr1 with gr6 = gr6 - gr0;	//Mantiss
	[ar5] = gr6;	//Exponent
	[ar0] = gr7;	//Sign
//39:   	return;

	pop ar1,gr1;
	pop ar0,gr0;
	ar7 = ar6;
	pop ar6,gr6;
return;                                  //<39,2>
	}	//asm
	return;

#endif	// !defined(__NM6403__) && !defined(__NM6405__)
}

// ConstructFloat --
//
//   float
//
float ConstructFloat(int Mantiss, int Exponent, int Sign, int ){
	float f;
	float *fp = &f;
	unsigned int *ip;
	ip= (unsigned int*)(fp);
	int i =	( ( (unsigned int)Mantiss)<<9)>>9;//				& 0x007fffff );
	i |=	( ( ((unsigned int)Exponent+0x7f)	<< 24 ) >> 1);//	& 0x7f800000 );
	i |=	( (	((unsigned int)Sign)			<< 31 )/*	& 0x80000000*/ );
	*ip = i;
	return *fp;
}

// ConstructDouble --
//
//   double
//
double ConstructDouble(LONG Mantiss, LONG Exponent, LONG Sign, int ){
	double f;
	double *fp = &f;
	ULONG *ip;
	ip= (ULONG*)(fp);
	*ip =	(	ULONG(Mantiss)				& 0x000fffffffffffff )  |
			( ( ULONG(Exponent+0x3ff)<< 52 )	& 0x7ff0000000000000 )  |
			( (	ULONG(Sign)			<< 63 )	& 0x8000000000000000 );
	return *fp;
}

// DstrDouble --
//
//   double
//
void DstrDouble(double f, LONG &Mantiss, int &Exponent,
					int &Sign){
	double *fp = &f;
	ULONG *ip;
	ip= (ULONG*)(fp);
	Mantiss = (LONG)( *ip &	0x000fffffffffffff );
	Exponent = (int)((( *ip & 0x7ff0000000000000 ) >> 52 ) - 0x3ff);
	Sign =  (int)(( *ip &		0x8000000000000000 ) >> 63);

	if ( Exponent !=0x400 && Exponent !=-(0x3ff))	// 0, inf, NAN, Denormal 
		Mantiss += (LONG)0x0010000000000000;	/* +1,   */
	return;
}

#ifdef __cplusplus
}
#endif  // __cplusplus
